/***************************************************************************
                           client.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _CLIENT_HPP
#define _CLIENT_HPP

class Client;
#include <string>
#include <config.h>
#include <clientlist.hpp>

class Client {
public:
  Client(ClientList *l, const string &nick, const string &ident, const string &hostmask,
	 const string &realname, bool oper=false);
  virtual ~Client();

  bool isOper() const 
  { return oper; };
  const string & getNickname() const 
  { return nickname; };
  const string & getIdent() const 
  { return ident; };
  const string & getHostmask() const 
  { return hostmask; };
  const string & getRealname() const 
  { return realname; };

  bool operator==(const string &cNick) const 
  { return nickname==cNick; };
  bool operator<(const string &cNick) const 
  { return nickname < cNick; };
  bool operator>(const string &cNick) const 
  { return nickname > cNick; };
 
  // provide chghost support
  void setIdent(const string &Ident) { ident=Ident; };
  void setHostmask(const string &Hostmask) { hostmask=Hostmask; };

  void setOper(bool Oper) { oper=Oper; };
  void setNickname(const string &newNick);

private:
  ClientList *root;
  string nickname;
  string ident;
  string hostmask;
  const string realname;
  bool oper;
};

#endif
