/***************************************************************************
                           clientlist.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _CLIENTLIST_HPP
#define _CLIENTLIST_HPP

class ClientList;
#include <set>
#include <client.hpp>
#include <config.h>

class ClientList : protected set<Client*>{
public:
  ClientList();
  virtual ~ClientList();

  void insertClient(Client *c);
  void eraseClient(Client *c);
  Client * getClient(const string &nickname);
  using set<Client*>::clear;

private:
  ClientList(const ClientList &);
};

class ClientListPredicate {
public:
  ClientListPredicate(const string &refName);
  bool operator() (const Client*c);

private:
  const string &refName;
};

#endif
