
/***************************************************************************
                           clienttaskset.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _CLIENTTASKSET_HPP
#define _CLIENTTASKSET_HPP

#include <set>
#include <string>
class ClientTaskSet;
#include <pstask.hpp>
#include <dereferencecomparator.hpp>
#include <config.h>

class ClientTaskSet : public set<const PSTask*, DereferenceLess<const PSTask*> >
{
public:
  ClientTaskSet();
  virtual ~ClientTaskSet();
  
  const PSTask * operator[] (const string &name);
  
  static void setDefaultKillTimeout(int newTimeout)
  { KILLTIMEOUT=newTimeout; }

private:
  void cleanUp();
  static timeout_t KILLTIMEOUT;
};

#endif
