
/***************************************************************************
                           dereferencecomparator.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _DEREFERENCE_LESS
#define _DEREFERENCE_LESS

template <typename T>
struct DereferenceLess : public binary_function<T, T, bool> {
  bool operator() ( T lhs, T rhs ) const
  { return *lhs < *rhs ; };
};

template <typename T>
struct DereferenceEqual : public binary_function<T, T, bool> {
  bool operator() ( T lhs, T rhs ) const
  { return *lhs == *rhs ; };
};

template <typename T>
struct DereferenceMore : public binary_function<T, T, bool> {
  bool operator() ( T lhs, T rhs ) const
  { return *lhs > *rhs ; };
};

#endif
