
/***************************************************************************
                           inethostaddress.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef _INETHOSTADDRESS_HPP
#define _INETHOSTADDRESS_HPP

#include <string>
extern "C" {
#include <netdb.h>
}
#include <config.h>

namespace procserv {

  class PSInetHostAddress {
  public:
    PSInetHostAddress();
    PSInetHostAddress(const char *name);
    PSInetHostAddress(const string &name);

    bool operator! () const;
    operator void*() const;
    const PSInetHostAddress & operator=(const char *name);
    const PSInetHostAddress & operator=(const string &name);
    const char * getName() 
    {
      if(he) return he->h_name;
      else return NULL;
    }  
    const hostent * getHostent() const { return he; };
    
  private:
    void init(const char *inetName);
    hostent *he;
  };
}

ostream& operator<< (ostream &, const procserv::PSInetHostAddress &addr);

#endif
