

#ifndef _LOGINS_HPP
#define _LOGINS_HPP

#include <map>
#include <string>
#include <xmlentityrepresentation.hpp>
#include <config.h>

class Logins : public map<const string, string>, public XMLEntityRepresentation {
public:
  Logins();
  Logins( const XMLEntity *e );
  virtual ~Logins();
  
  bool process( const XMLEntity *e );
  bool auth(const string & login, const string &pass);

  const static string XMLENTITY_NAME;

private:
  void processSubXMLEntities( XMLEntity::SubEntitiesList::const_iterator begin,
			      XMLEntity::SubEntitiesList::const_iterator end );
  void processUserXMLEntity( XMLEntity &e );

  const static string XMLENTITY_USER_NAME;
  const static string XMLENTITY_USER_AUTHNAME;
  const static string XMLENTITY_USER_PASSWORD;
};

#endif
