
/***************************************************************************
                           main.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _MAIN_HPP
#define _MAIN_HPP

#include <procserv.hpp>
#include <config.h>
#include <psxmlconfigfile.hpp>
#include <config.h>

int main(int argc, char **argv);

static void createFromXML(bool quit=true);
static void startProcServ(PSConfig &config, 
			  const PSInetHostAddress &addr, tpport_t port,
			  Logins *auth, VProgs *vprogs);
static PSXMLConfigFile *createXMLConfig(const char *filename);
bool addSignalHandlers();
void parseArgs(int argc, char **argv);
// static void checkConfigFile(PSConfigFile &config);
// static void checkConfigFile(PSConfigFile &config, bool quit);
static PSConfig* makePSConfig(PSXMLConfigFile *c);
static VProgs* makeVProgsConfig(PSXMLConfigFile *c);
static Logins* makeAuthConfig(PSXMLConfigFile *c);

static void printHelp(const char *);
// static void printConfigCheckFailed(const string &entry, bool quit);
static void printXMLConfigError(const string &);

void sigIntHandler(int signum);
void sigQuitHandler(int signum);
void sigTermHandler(int signum);
void sigHupHandler(int signum);

#endif
