
/***************************************************************************
                           process.cpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _PROCESS_HPP
#define _PROCESS_HPP

#include <string>
#include <cc++/thread.h>
#include <cstdio>
#include <config.h>

// todo:
// - implement checks in 'Initial', 'Final', 'Run', etc. checks 
//     of the state of the thread
using namespace ost;

class Process : private PosixThread
{
public:
  Process(const string &cmd, const string &args);
  virtual ~Process();
  void sendString(const string &msg) ;
  void start();

  const string &getCommand() const;
  const string &getArguments() const;
  unsigned int getPID() const;
  
private:
  void init();
  void initArgs(char **, int);
  virtual void Initial();
  virtual void Final();
  virtual void Run();
  
protected:
  virtual void onStart() {};
  virtual void onTerminate() {};
  virtual void OnSignal(int signo);
  virtual void OnHangup();

  pid_t pid;
  const string command;
  const string arguments;

private:
  bool exec();

  bool running;
  FILE *childStdIn;

  Process(const Process &p);
  const Process & operator= ( const Process &p );
};


#endif
