
/***************************************************************************
                           procserv.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef _PROCSERV_HPP
#define _PROCSERV_HPP

#include <psircconnection.hpp>
#include <logins.hpp>
#include <vprogs.hpp>
#include <config.h>

class ProcServ {
public:
  ProcServ( const PSInetHostAddress &addr, tpport_t port,
	    const string &servname,const string &password,
	    Logins *auth, VProgs *vprogs );
  virtual ~ProcServ();

  void start();
  void rehash( Logins *a, VProgs *v );

  void quitFromServer( const char *cause )
  { conn->quitFromServer(cause); };  

private:
  PSIRCConnection *conn;

  ProcServ();
  ProcServ(const ProcServ &);
};

#endif
