/***************************************************************************
                           psconfig.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _PSCONFIG_HPP
#define _PSCONFIG_HPP

#include <string>
#include <xmlentityrepresentation.hpp>

using namespace std;

class PSConfig : public XMLEntityRepresentation
{
public:
  PSConfig();
  PSConfig( const XMLEntity *e );
  virtual ~PSConfig();

  virtual bool process( const XMLEntity *e );

  const string &getRemoteServName() 
  { return remoteServName; };
  int getRemotePort() 
  { return remotePort; };
  const string &getRemoteServPassword()
  { return remoteServPassword; };
  const string &getLocalHostname() 
  { return localHostname; };
  const string &getLocalServerDescription()
  { return localServerDescription; };
  const string &getManagerNick()
  { return managerNick; };
  const string &getManagerIdent()
  { return managerIdent; };
  const string &getManagerAddress()
  { return managerAddress; };
  const string &getManagerRealname()
  { return managerRealname; };
  const string &getManagerModes()
  { return managerModes; };

  static const XMLToken XMLENTITY_NAME;

private:
  string remoteServName;
  unsigned int remotePort;
  string remoteServPassword;

  string localHostname;
  string localServerDescription;

  string managerNick;
  string managerIdent;
  string managerAddress;
  string managerRealname;
  string managerModes;

  static const XMLToken XMLENTITY_REMOTE_NAME;
  static const XMLToken XMLENTITY_REMOTE_SERVER;
  static const XMLToken XMLENTITY_REMOTE_PORT;
  static const XMLToken XMLENTITY_REMOTE_PASSWORD;
  static const XMLToken XMLENTITY_LOCAL_NAME;
  static const XMLToken XMLENTITY_LOCAL_DESCRIPTION;
  static const XMLToken XMLENTITY_LOCAL_HOSTNAME;
  static const XMLToken XMLENTITY_MANAGER_NAME;
  static const XMLToken XMLENTITY_MANAGER_NICK;
  static const XMLToken XMLENTITY_MANAGER_IDENT;
  static const XMLToken XMLENTITY_MANAGER_ADDRESS;
  static const XMLToken XMLENTITY_MANAGER_REALNAME;
  static const XMLToken XMLENTITY_MANAGER_MODES;

  void processXMLSubEntities( XMLEntity::SubEntitiesList::const_iterator begin,
			      XMLEntity::SubEntitiesList::const_iterator end);
  void processManagerXMLEntity( XMLEntity &e );
  void processLocalXMLEntity  ( XMLEntity &e );
  void processRemoteXMLEntity ( XMLEntity &e );

  PSConfig( const PSConfig &);
  const PSConfig & operator= ( const PSConfig & );
};

#endif
