
/***************************************************************************
                           pstask.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _PSTASK_HPP
#define _PSTASK_HPP

class PSTask;
#include <string>
#include <process.hpp>
#include <processalias.hpp>
#include <clienttaskset.hpp>
#include <psircconnection.hpp>
#include <config.h>

class PSTask : public Process {
public:
  PSTask( PSIRCConnection *con, ClientTaskSet *list,
	  const ProcessAlias *ps, const string &options,
	  bool autostart=true );
  virtual ~PSTask();

  bool operator<( const string &name ) const 
  { return myname < name; };
  bool operator<( const PSTask &task ) const
  { return myname < task.myname; };

  void terminate();
  void kill();
  void reload();
  const string & getIRCName() const
  { return myname; };
  
protected:
  virtual void onTerminate();

private:
  PSIRCConnection *ircConn;
  string myname; // nickname in irc
  ClientTaskSet *taskSet;
  const ProcessAlias *p;

  void init( bool autostart );
  void constructName( int pid );
};

#endif
