
/***************************************************************************
                           psxmlstream.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _PSXMLSTREAM_HPP
#define _PSXMLSTREAM_HPP

#include <list>
#include <xmlstreamimpl.hpp>
#include <xmlcontainer.hpp>
#include <config.h>

class PSXMLStream : public XMLStreamImpl
{
public:
  PSXMLStream(streambuf *buf, XMLContainer *entities);
  virtual ~PSXMLStream();
  
  XMLContainer * getEntities() { return entities; };

protected:
  virtual void onStartEntity(const unsigned char *name, unsigned int len);
  virtual void onEntityValue(const unsigned char *val, unsigned int len);
  virtual void onEndEntity(const unsigned char *name, unsigned int len);

private:
  enum { UNSET=-1, ENTITY_START, ENTITY_VAL, ENTITY_END } lastToken;
  XMLToken lastKey;
  XMLEntity *lastEntity;
  XMLContainer *entities;

  PSXMLStream();
  PSXMLStream(const PSXMLStream &);
  const PSXMLStream & operator= (const PSXMLStream &);
  
};

#endif
