#ifndef SPSTREAM_H
#define SPSTREAM_H

// original implementation that works with pipes/sockets/ etc
// Developed by Nitin Bhide (nitinbhide@yahoo.com)
//

#include <fstream>
#include <cstdio>

using namespace std;

class basic_spofstream : public ofstream
{
  typedef filebuf spfilebuff;
  typedef streambuf spstreambuff;
  typedef ios spbaseios;
  
public :
  basic_spofstream(int fd)
  {
    m_pFile = NULL;
    pRdBuff = new spfilebuff(fd);
    pOldRdBuff = spbaseios::rdbuf();
    spbaseios::rdbuf(pRdBuff);
  }
  virtual ~basic_spofstream()
  {
    spbaseios::rdbuf(pOldRdBuff);
    pRdBuff->close();
    delete pRdBuff;
    pRdBuff = NULL;
    m_pFile = NULL;
  }
  
private :
  spfilebuff *pRdBuff;
  spstreambuff *pOldRdBuff;
  
  int m_fd;
  FILE *m_pFile;
};

typedef basic_spofstream spofstream;
#endif //SPSTREAM_H
