
/***************************************************************************
                           vprogsxmlentity.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _VPROGS_HPP
#define _VPROGS_HPP

#include <map>
#include <string>
#include <xmlentityrepresentation.hpp>
#include <processalias.hpp>
#include <config.h>

class VProgs : public map<const string, const ProcessAlias *> , public XMLEntityRepresentation {
public:
  VProgs();
  VProgs( const XMLEntity *c );
  virtual ~VProgs();

  virtual bool process ( const XMLEntity *entity );

  static const string XMLENTITY_NAME;  

private:
  void processXMLEntity( XMLEntity &entity );
  void processSubXMLEntities( XMLEntity::SubEntitiesList::const_iterator begin, 
			     XMLEntity::SubEntitiesList::const_iterator end );

  bool checkXMLProcessEntity ( XMLEntity &entity );
  void insertXMLProcessEntity ( XMLEntity &entity );
  void cleanUp();

  static const string XMLENTITY_OVERWRITEOPTIONS;
  static const string XMLENTITY_DEFAULTIRCIDENT;
  static const string XMLENTITY_DEFAULTIRCADDRESS;
  static const string XMLENTITY_DEFAULTIRCREALNAME;
  static const string XMLENTITY_DEFAULTIRCMODES;
  static const string XMLENTITY_DEFAULTIRCCHANNEL;

  static const string XMLENTITY_PROCESS_NAME;
  static const string XMLENTITY_PROCESS_ID;
  static const string XMLENTITY_PROCESS_COMMAND;
  static const string XMLENTITY_PROCESS_OPTIONS;
  static const string XMLENTITY_PROCESS_IRCNAME;
  static const string XMLENTITY_PROCESS_IRCIDENT;
  static const string XMLENTITY_PROCESS_IRCADDRESS;
  static const string XMLENTITY_PROCESS_IRCREALNAME;
  static const string XMLENTITY_PROCESS_IRCMODES;
  static const string XMLENTITY_PROCESS_IRCCHANNEL;
  static const string XMLENTITY_PROCESS_OVERWRITEOPTIONS;
  
  VProgs( const VProgs & );
  const VProgs & operator = (const VProgs &);
};

#endif



