
/***************************************************************************
                           xmlcontainer.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef _XMLCONTAINER_HPP
#define _XMLCONTAINER_HPP

#include <set>
#include <xmltoken.hpp>
#include <xmlentity.hpp>
#include <config.h>

class XMLContainer : public set<XMLEntity *>
{
public:
  XMLContainer();

  virtual ~XMLContainer();
  // quick and dirty
  XMLEntity * operator[](const string &type) const;

protected:
  void cleanUp();
};

class XMLContainerSetPredicate {
public:
  XMLContainerSetPredicate(const string &typeName);
  bool operator() (const XMLEntity *c);

private:
  const string typeName;
};

ostream & operator << (ostream &, const XMLContainer &);


#endif
