
/***************************************************************************
                           xmlstreamimpl.hpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#ifndef _XMLSTREAMIMPL_HPP
#define _XMLSTREAMIMPL_HPP

#include <cc++/xml.h>
#include <iostream>
#include <string>
#include <config.h>

using namespace std;
using namespace ost;

// todo: implement stream closing
class XMLStreamImpl : protected XMLStream {
public:
  XMLStreamImpl(streambuf *buf);
  virtual ~XMLStreamImpl();
  
  using XMLStream::Parse;
  
protected:
  virtual void onStartEntity(const unsigned char *buffer, unsigned int len)
  {}
  virtual void onEntityValue(const unsigned char *val, unsigned int len)
  {}
  virtual void onEndEntity(const unsigned char *buffer, unsigned int len)
  {}
  virtual void onParserStart()
  {}
  virtual void onParserEnd()
  {}

private:
  virtual int Read(unsigned char *buffer, int len);
  virtual void characters(const unsigned char *buffer, unsigned int len);
  virtual void startDocument();
  virtual void endDocument();
  virtual void startElement(const unsigned char *name, const unsigned char **attr);
  virtual void endElement(const unsigned char *name);
  static int my_strlen(const unsigned char *c);

private:
  istream in;
};


#endif
