/***************************************************************************
                           client.cpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <client.hpp>

Client::Client(ClientList *clients, 
	       const string &nick, const string &Ident, const string &Hostmask,
	       const string &Realname, bool Oper) :
  root(clients), nickname(nick), ident(Ident), hostmask(Hostmask), realname(Realname), oper(Oper)
{
#ifdef VERBOSE_MEMORY
  cout << "Client] created for " << nick << endl;
#endif
  root->insertClient(const_cast<Client*>(this));
}

Client::~Client()
{
  root->eraseClient(const_cast<Client*>(this));
#ifdef VERBOSE_MEMORY
  cout << "Client] destroyed (" << nickname << ")" << endl;
#endif
}

void Client::setNickname(const string &newNick) 
{
#ifdef DEBUG
  cout << "Client] setting new nickname: " << nickname << "->" << newNick << endl;
#endif

  // todo: improve.
  root->eraseClient(const_cast<Client*>(this));
  nickname=newNick;
  root->insertClient(const_cast<Client*>(this));

}
