/***************************************************************************
                           clientlist.cpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <clientlist.hpp>
#include <iostream>
#include <algorithm>
#include <config.h>

ClientList::ClientList() 
  : set<Client*>()
{
#ifdef VERBOSE_MEMORY
  cout << "ClientList] created" << endl;
#endif
}


ClientList::~ClientList()
{
#ifdef VERBOSE_MEMORY
  cout << "ClientList] destroyed" << endl;
#endif  
}

void ClientList::insertClient(Client *c)
{
  if(c) insert(c);
  else cout << "ClientList] ::insertClient(): arg == NULL" << endl;
}

void ClientList::eraseClient(Client *c)
{
  if(c) erase(c);
  else cout << "ClientList] ::removeClient(): arg == NULL" << endl;
}

Client * ClientList::getClient(const string &nickname)
{
  iterator it=find_if(begin(), end(), ClientListPredicate(nickname));
  if(it==end()) return NULL;
  else return *it;
}

ClientListPredicate::ClientListPredicate(const string &nickname)
  : refName(nickname)
{
}

bool ClientListPredicate::operator() (const Client *c)
{
  return (*c)==refName;
}
