
/***************************************************************************
                           inethostaddress.cpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

extern "C" {
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
}
#include <inethostaddress.hpp>
#include <cstdio>


ostream& operator<< (ostream &outs, const procserv::PSInetHostAddress &addr)
{
  outs << addr.getHostent()->h_name;
  return outs;
}

procserv::PSInetHostAddress::PSInetHostAddress() : he(NULL)
{
}

procserv::PSInetHostAddress::PSInetHostAddress( const char *name )
{
  init( name );
}

procserv::PSInetHostAddress::PSInetHostAddress( const string &name )
{
  init( name.c_str() );
}

bool procserv::PSInetHostAddress::operator! () const
{
  return he == NULL; 
}

procserv::PSInetHostAddress::operator void* () const
{
  return he;
}

void procserv::PSInetHostAddress::init(const char *name)
{
  he=gethostbyname( name );
}

const procserv::PSInetHostAddress & procserv::PSInetHostAddress::operator=( const char *name )
{
  if( he ) free( he );
  init( name );
  return *this;
}

const procserv::PSInetHostAddress & procserv::PSInetHostAddress::operator= ( const string &name )
{
  if( he ) free( he );
  init( name.c_str() );
  return *this;
}
