
/***************************************************************************
                           processalias.cpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <processalias.hpp>

string ProcessAlias::DEFAULT_IDENT    = "procserv";
string ProcessAlias::DEFAULT_ADDRESS  = "subprocess";
string ProcessAlias::DEFAULT_MODES    = "0"; 
string ProcessAlias::DEFAULT_REALNAME = "ProcServ 05 subprocess"; 
string ProcessAlias::DEFAULT_CHANNEL  = "#procserv";
bool ProcessAlias::OVERWRITE_OPTIONS  = false;

ProcessAlias::ProcessAlias() 
  : command(), options(), ircNick(), ircIdent(), ircAddress(),
    ircRealname(), ircModes(), ircChannel(), overwrite( OVERWRITE_OPTIONS ),
    references( 0 )
{
#ifdef VERBOSE_MEMORY
  cout << "ProcessAlias] created" << endl;
#endif
}

ProcessAlias::ProcessAlias(const string &Command, const string &Options,
			   const string &IrcNick, const string &IrcIdent,
			   const string &IrcAddress, const string &IrcRealname,
			   const string &IrcModes, const string &IrcChannel,
			   bool ovwrt)
  : command( Command ), options( Options ), 
    ircNick( IrcNick ), ircIdent( IrcIdent ),
    ircAddress( IrcAddress ), ircRealname( IrcRealname ),
    ircModes( IrcModes ), ircChannel( IrcChannel ), overwrite( ovwrt ),
    references( 0 )
{
#ifdef VERBOSE_MEMORY
  cout << "ProcessAlias] created" << endl;
#endif
}

ProcessAlias::~ProcessAlias()
{
#ifdef VERBOSE_MEMORY
  cout << "ProcessAlias] destroyed" << endl;
#endif
}

ostream & operator << (ostream &out, const ProcessAlias &pa)
{
  out << " command(" << pa.getCommand() << ')'
      << " options(" << pa.getOptions() << ')'
      << " nick(" << pa.getIRCName() << ')'
      << " ident(" << pa.getIRCIdent() << ')'
      << " address(" << pa.getIRCAddress() << ')'
      << " realname(" << pa.getIRCRealname() << ')'
      << " modes(" << pa.getIRCModes() << ')'
      << " channel(" << pa.getIRCChannel() << ')'
      << " instances(" << pa.getReferences() << ')'
      << " overwriteOptions(" << pa.overwriteOptions() << ')';
  return out;
}
