
/***************************************************************************
                           procserv.cpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include <procserv.hpp>
#include <iostream>

ProcServ::ProcServ(const PSInetHostAddress &addr, tpport_t port,
		   const string &servname, const string &password,
		   Logins *authFile, VProgs *vprogs)
  : conn(new PSIRCConnection(addr, port, servname, password, 
			     vprogs, authFile))
{
#ifdef VERBOSE_MEMORY
  cout << "ProcServ] created" << endl;
#endif
}

ProcServ::~ProcServ()
{
  delete conn;

#ifdef VERBOSE_MEMORY
  cout << "ProcServ] destroyed" << endl;
#endif
}

void ProcServ::start()
{
  conn->Connect();
  conn->startPolling();
}

// warning: no resource freeing done.
// this has to be implemented by the caller
void ProcServ::rehash(Logins *a, VProgs *v) 
{
  conn->setNewAuthData(a);
  conn->setNewVProgs(v);

#ifdef DEBUG
  cout << "ProcServ] set new auth data / set new vprog" << endl;
#endif
}
