
/***************************************************************************
                           xmlentity.cpp
                           -------------------
    copyright            : (C) 2001 by Martin Scholl
    email                : ms@deridiot.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "xmlentity.hpp"

ostream & operator <<(ostream &out, const XMLEntity &entity)
{
  cout << '<' << entity.getType() << '>' << endl;
  const XMLEntity::SubEntitiesList &subEntities=entity.getSubEntities();
  
  for( XMLEntity::SubEntitiesList::const_iterator it=subEntities.begin(); 
       it != subEntities.end(); ++it ) cout << *(*it) << endl;

  for(XMLEntity::const_iterator it=entity.begin(); it != entity.end(); ++it) {
    cout << '<' << it->first << '>' << it->second << "</" << it->first << '>' << endl;
  }
  cout << "</" << entity.getType() << '>';
  return out;
};
